Package org.zkoss.web.servlet.dsp.action

## Class AbstractAction

- java.lang.Object
- - org.zkoss.web.servlet.dsp.action.AbstractAction

- All Implemented Interfaces:
    `Action`
  Direct Known Subclasses:
    `Box`, `Choose`, `ForEach`, `If`, `Img`, `Include`, `Otherwise`, `Out`, `Page`, `Remove`, `Set`, `When`

      public abstract class AbstractAction
      extends java.lang.Object
      implements Action

  A skeletal implementation to simplify the implementation of actions.
  Author:
    tomyeh

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractAction()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected static void` | `append​(java.lang.StringBuffer sb, java.lang.String attrName, boolean avail)` | Appends an attribute to the string buffer, if `avail` is true.
    `protected static void` | `append​(java.lang.StringBuffer sb, java.lang.String attrName, int val)` | Appends an attribute to the string buffer.
    `protected static void` | `append​(java.lang.StringBuffer sb, java.lang.String attrName, java.lang.String attrValue)` | Appends an attribute to the string buffer, if `attrValue` is not null.
    `boolean` | `getIf()` | Returns the if condition.
    `boolean` | `getUnless()` | Returns the unless condition.
    `boolean` | `isEffective()` | Returns whether this tag is effective.
    `void` | `setIf​(boolean ifcond)` | Sets the if condition.
    `void` | `setUnless​(boolean unless)` | Sets the unless condition.
    `protected static int` | `toScope​(java.lang.String scope)` | Returns one of `ActionContext.PAGE_SCOPE`, `ActionContext.REQUEST_SCOPE`, `ActionContext.SESSION_SCOPE` and `ActionContext.APPLICATION_SCOPE` of the specified scope name.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.zkoss.web.servlet.dsp.action.Action

      `render`

- - ### Constructor Detail

    - #### AbstractAction

          public AbstractAction()

  - ### Method Detail

    - #### getIf

          public boolean getIf()

      Returns the if condition. If the if condition is false, this tag is ignored. If the unless condition (`getUnless()`) is true, this tag is ignored, too. Tags deriving from this class shall invoke `isEffective()` to know the result.

      Default: true.

    - #### setIf

          public void setIf​(boolean ifcond)

      Sets the if condition.

    - #### getUnless

          public boolean getUnless()

      Returns the unless condition. If the unless condition is true, this tag is ignored. If the if condition (`getIf()`) is true, this tag is ignored, too. Tags deriving from this class shall invoke `isEffective()` to know the result.

      Default: false.

    - #### setUnless

          public void setUnless​(boolean unless)

      Sets the unless condition.

    - #### isEffective

          public boolean isEffective()

      Returns whether this tag is effective. If false, this tag does nothing (as if not specified at all).

    - #### toScope

          protected static final int toScope​(java.lang.String scope)

      Returns one of `ActionContext.PAGE_SCOPE`, `ActionContext.REQUEST_SCOPE`, `ActionContext.SESSION_SCOPE` and `ActionContext.APPLICATION_SCOPE` of the specified scope name.
      Parameters:
        `scope` - one of "page", "request", "session" and "application".

    - #### append

          protected static final void append​(java.lang.StringBuffer sb,
                                             java.lang.String attrName,
                                             java.lang.String attrValue)

      Appends an attribute to the string buffer, if `attrValue` is not null.

    - #### append

          protected static void append​(java.lang.StringBuffer sb,
                                       java.lang.String attrName,
                                       boolean avail)

      Appends an attribute to the string buffer, if `avail` is true.

    - #### append

          protected static final void append​(java.lang.StringBuffer sb,
                                             java.lang.String attrName,
                                             int val)

      Appends an attribute to the string buffer.